pathLib = require "path"
_ = require "underscore"

helpersPath = null
loadHelpers = do ->
  paths = ["#{process.cwd()}/helpers.coffee", "#{process.cwd()}/helpers.js"]
  for path in paths
    if pathLib.existsSync path
      require path
      helpersPath = path

dk.plugin "template.helpers", ["assets"], ->
  mod = {}
  allHelpers = {}

  mod.config = (opts) ->
    if opts.path
      helpersPath = opts.path

  mod.run = ->
    includeHelpers()

  mod.add = (newHelpers) ->
    _.each newHelpers, (func, name) ->
      allHelpers[name] = func

  mod.all = -> allHelpers

  # PRIVATE METHODS
  includeHelpers = ->
    dk.assets.package "/js/dk-template-helpers.js", "#{__dirname}/../public/js/dk-template-helpers.coffee"
    dk.assets.package "/js/dk/template/helpers.js", helpersPath if helpersPath

  mod
